/*
 * $Id: config.h.in,v 1.45.2.2 2000/07/18 03:48:06 wessels Exp $
 *
 * AUTHOR: Duane Wessels
 *
 * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
 * --------------------------------------------------------
 *
 *  Squid is the result of efforts by numerous individuals from the
 *  Internet community.  Development is led by Duane Wessels of the
 *  National Laboratory for Applied Network Research and funded by
 *  the National Science Foundation.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
 *  
 */

#ifndef _CONFIG_H_
#define _CONFIG_H_

#include "autoconf.h"	/* For GNU autoconf variables */
#include "version.h"

/****************************************************************************
 *--------------------------------------------------------------------------*
 * DO *NOT* MAKE ANY CHANGES below here unless you know what you're doing...*
 *--------------------------------------------------------------------------*
 ****************************************************************************/

#ifdef USE_POSIX_REGEX
#ifndef USE_RE_SYNTAX
#define USE_RE_SYNTAX	REG_EXTENDED	/* default Syntax */
#endif
#endif

/* define the _SQUID_TYPE_ based on a guess of the OS */
#if defined(__sun__) || defined(__sun)		/* SUN */
#define _SQUID_SUN_
#if defined(__SVR4)				/* SOLARIS */
#define _SQUID_SOLARIS_
#else						/* SUNOS */
#define _SQUID_SUNOS_
#endif

#elif defined(__hpux)                           /* HP-UX - SysV-like? */
#define _SQUID_HPUX_
#define _SQUID_SYSV_

#elif defined(__osf__)                          /* OSF/1 */
#define _SQUID_OSF_

#elif defined(__ultrix)				/* Ultrix */
#define _SQUID_ULTRIX_

#elif defined(_AIX)                          	/* AIX */
#define _SQUID_AIX_

#elif defined(__linux__)                        /* Linux */
#define _SQUID_LINUX_
#if USE_ASYNC_IO
#define _SQUID_LINUX_THREADS_
#endif

#elif defined(__FreeBSD__)			/* FreeBSD */
#define _SQUID_FREEBSD_
#if USE_ASYNC_IO && defined(LINUXTHREADS)
#define _SQUID_LINUX_THREADS_
#endif

#elif defined(__sgi__)	|| defined(sgi) || defined(__sgi) /* SGI */
#define _SQUID_SGI_
#if !defined(_SVR4_SOURCE)
#define _SVR4_SOURCE		/* for tempnam(3) */
#endif
#if USE_ASYNC_IO
#define _ABI_SOURCE
#endif /* USE_ASYNC_IO */

#elif defined(__NeXT__)
#define _SQUID_NEXT_

#elif defined(__bsdi__)
#define _SQUID_BSDI_                          /* BSD/OS */

#elif defined(__NetBSD__)
#define _SQUID_NETBSD_

#elif defined(__CYGWIN32__)  || defined(__CYGWIN__) || defined(WIN32) || defined(WINNT) || defined(__WIN32__) || defined(__WIN32)
#define _SQUID_MSWIN_
#define SQUID_MAXFD 128
#include <stddef.h>
#define FD_SETSIZE 128
#include <ws2spi.h>
//#define DELAY_POOLS 1
#include <sys/timeb.h>
#include <malloc.h>
#include "GNUregex.h"
#include "readdir.h"

extern int Win32SockInit(void);
#define SQUIDHOSTNAMELEN 128
typedef unsigned char *caddr_t;
#undef FD_CLOSE
#undef FD_OPEN
#undef FD_READ
#undef FD_WRITE
#undef FD_SETSIZE
#define EISCONN WSAEISCONN
#define EINPROGRESS WSAEINPROGRESS 
#define EWOULDBLOCK WSAEWOULDBLOCK
#define EALREADY WSAEALREADY
#define ETIMEDOUT WSAETIMEDOUT
#define uid_t int
#define gid_t int
#define xstrdup _strdup
#define snprintf _snprintf
#define chdir _chdir
#define getcwd _getcwd
#define strcasecmp _stricmp
#define strncasecmp _strnicmp
#define vsnprintf _vsnprintf
#define getpid _getpid
#define mkdir _mkdir
#define	S_ISDIR(m)	(((m) & _S_IFDIR) == _S_IFDIR)
#define getpid _getpid
#if !(defined (STORE_DIR_C) || defined (STORE_IO_C))
//#define open(x,y,z) _open(x,y,z)
//#define close(x) _close(x)
#endif

#if defined (COMM_C) || defined (COMM_SELECT_C) 
#define recv(x,y,z) recv(x,y,z,0)
#define send(x,y,z) send(x,y,z,0)
#define fd_bytes(x,y,z) sd_bytes(x,y,z)
#define fd_note(x,y) sd_note(x,y)
#define fd_open(x,y,z) sd_open(x,y,z)
#define fd_close(x) sd_close(x)
#define ignoreErrno(x) WSAignoreErrno(x)
#endif

#if defined (ICP_V2_C)
#define fd_note(x,y) sd_note(x,y)
#define ignoreErrno(x) WSAignoreErrno(x)
#define commSetSelect(x,y,z,u,v) commSetSelectS(x,y,z,u,v)
#endif

#if defined(WHOIS_C) || defined(WAIS_C) 
#define send(x,y,z) send(x,y,z,0)
#define recv(x,y,z) recv(x,y,z,0)
#define fd_bytes(x,y,z) sd_bytes(x,y,z)
#define ignoreErrno(x) WSAignoreErrno(x)
#define commSetSelect(x,y,z,u,v) commSetSelectS(x,y,z,u,v)
#endif

#if defined (SSL_C) || defined (PCONN_C) || defined (PUMP_C) ||  \
	defined (HTTP_C) || defined (HTCP_C) || defined (HELPER_C) || defined (CLIENT_SIDE_C) \
	|| defined (FTP_C) || defined (GOPHER_C) || defined(IDENT_C) || \
	defined (ICMP_C) || defined (FORWARD_C) || defined (DNS_INTERNAL_C) 
#define recv(x,y,z) recv(x,y,z,0)
#define send(x,y,z) send(x,y,z,0)
#define fd_bytes(x,y,z) sd_bytes(x,y,z)
#define fd_note(x,y) sd_note(x,y)
#define ignoreErrno(x) WSAignoreErrno(x)
#define commSetSelect(x,y,z,u,v) commSetSelectS(x,y,z,u,v)
#endif


#define	SIGHUP	1	/* hangup */
#define	SIGKILL	9	/* kill (cannot be caught or ignored) */
#define	SIGBUS	10	/* bus error */
#define	SIGPIPE	13	/* write on a pipe with no one to read it */
#define	SIGCHLD	20	/* to parent on child stop or exit */
#define SIGUSR1 30	/* user defined signal 1 */
#define SIGUSR2 31	/* user defined signal 2 */
extern void gettimeofday( struct timeval * ,void *);

#elif defined(__APPLE__)
#define _SQUID_APPLE_

#elif defined(sony_news) && defined(__svr4)
#define _SQUID_NEWSOS6_

#elif defined(__EMX__) || defined(OS2) || defined(__OS2__)
#define _SQUID_OS2_
/*
 *  FIXME: the os2 port of bash seems to have problems checking
 *  the return codes of programs in if statements.  These options
 *  need to be overridden.
 */
#ifndef socklen_t
#define socklen_t int
#endif
#ifndef fd_mask
#define fd_mask unsigned long
#endif
#endif

#if !defined(CACHE_HTTP_PORT)
#define CACHE_HTTP_PORT 3128
#endif

#if !defined(CACHE_ICP_PORT)
#define CACHE_ICP_PORT 3130
#endif

#if !defined(CACHEMGR_HOSTNAME)
#define CACHEMGR_HOSTNAME "localhost"
#endif

#if SQUID_UDP_SO_SNDBUF > 16384
#undef SQUID_UDP_SO_SNDBUF
#define SQUID_UDP_SO_SNDBUF 16384
#endif

#if SQUID_UDP_SO_RCVBUF > 16384
#undef SQUID_UDP_SO_RCVBUF
#define SQUID_UDP_SO_RCVBUF 16384
#endif

#ifdef HAVE_MEMCPY
#define xmemcpy(d,s,n) memcpy((d),(s),(n))
#elif HAVE_BCOPY
#define xmemcpy(d,s,n) bcopy((s),(d),(n))
#elif HAVE_MEMMOVE
#define xmemcpy(d,s,n) memmove((d),(s),(n))
#endif

#ifdef HAVE_MEMMOVE
#define xmemmove(d,s,n) memmove((d),(s),(n))
#elif HAVE_BCOPY
#define xmemmove(d,s,n) bcopy((s),(d),(n))
#endif

#define xisspace(x) isspace((unsigned char)x)
#define xtoupper(x) toupper((unsigned char)x)
#define xtolower(x) tolower((unsigned char)x)
#define xisdigit(x) isdigit((unsigned char)x)
#define xisascii(x) isascii((unsigned char)x)
#define xislower(x) islower((unsigned char)x)
#define xisalpha(x) isalpha((unsigned char)x)

#if HAVE_RANDOM
#define squid_random random
#define squid_srandom srandom
#elif HAVE_LRAND48
#define squid_random lrand48
#define squid_srandom srand48
#else
#define squid_random rand
#define squid_srandom srand
#endif

/* 32 bit integer compatability hack */
#if SIZEOF_INT == 4
typedef int num32;
typedef unsigned int u_num32;
#elif SIZEOF_LONG == 4
typedef long num32;
typedef unsigned long u_num32;
#else
typedef long num32;             /* assume that long's are 32bit */
typedef unsigned long u_num32;
#endif
#define NUM32LEN sizeof(num32)  /* this should always be 4 */

#endif /* _CONFIG_H_ */
